/* rpcdesign.c generated by valac 0.20.1, the Vala compiler
 * generated from rpcdesign.vala, do not modify */

/*
 *  This file is part of librpc.
 *  (c) Copyright 2013 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  librpc is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  librpc is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with librpc.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "config.h"
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_RPC_DESIGN (rpc_design_get_type ())
#define RPC_DESIGN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RPC_DESIGN, RpcDesign))
#define RPC_DESIGN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RPC_DESIGN, RpcDesignClass))
#define IS_RPC_DESIGN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RPC_DESIGN))
#define IS_RPC_DESIGN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RPC_DESIGN))
#define RPC_DESIGN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RPC_DESIGN, RpcDesignClass))

typedef struct _RpcDesign RpcDesign;
typedef struct _RpcDesignClass RpcDesignClass;
typedef struct _RpcDesignPrivate RpcDesignPrivate;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecRpcDesign ParamSpecRpcDesign;

struct _RpcDesign {
	GTypeInstance parent_instance;
	volatile int ref_count;
	RpcDesignPrivate * priv;
};

struct _RpcDesignClass {
	GTypeClass parent_class;
	void (*finalize) (RpcDesign *self);
};

struct _ParamSpecRpcDesign {
	GParamSpec parent_instance;
};


static gpointer rpc_design_parent_class = NULL;
static gboolean rpc_design_version;
static gboolean rpc_design_version = FALSE;
static gboolean rpc_design_force_ovw;
static gboolean rpc_design_force_ovw = FALSE;
static gboolean rpc_design_only_first_pass;
static gboolean rpc_design_only_first_pass = FALSE;
static gboolean rpc_design_only_second_pass;
static gboolean rpc_design_only_second_pass = FALSE;
static gchar* rpc_design_input_file;
static gchar* rpc_design_input_file = NULL;
static gchar* rpc_design_stub_file;
static gchar* rpc_design_stub_file = NULL;
static gchar* rpc_design_skel_file;
static gchar* rpc_design_skel_file = NULL;
static gchar* rpc_design_temp_file;
static gchar* rpc_design_temp_file = NULL;

gpointer rpc_design_ref (gpointer instance);
void rpc_design_unref (gpointer instance);
GParamSpec* param_spec_rpc_design (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_rpc_design (GValue* value, gpointer v_object);
void value_take_rpc_design (GValue* value, gpointer v_object);
gpointer value_get_rpc_design (const GValue* value);
GType rpc_design_get_type (void) G_GNUC_CONST;
enum  {
	RPC_DESIGN_DUMMY_PROPERTY
};
#define RPC_DESIGN_def_input_file "rpc_interfaces.vala"
#define RPC_DESIGN_def_stub_file "generated_stub.vala"
#define RPC_DESIGN_def_skel_file "generated_skeleton.vala"
#define RPC_DESIGN_def_temp_file "output.rpcdef"
gint rpc_design_main (gchar** args, int args_length1);
void first_pass_firstpass (const gchar* if_name, const gchar* of_name);
void second_pass_secondpass (const gchar* if_name, const gchar* stub_name, const gchar* skel_name);
RpcDesign* rpc_design_new (void);
RpcDesign* rpc_design_construct (GType object_type);
static void rpc_design_finalize (RpcDesign* obj);

static const GOptionEntry RPC_DESIGN_options[9] = {{"version", (gchar) 0, 0, G_OPTION_ARG_NONE, &rpc_design_version, "Display version number", NULL}, {"force", 'f', 0, G_OPTION_ARG_NONE, &rpc_design_force_ovw, "Force overwirte", NULL}, {"firstpass", '1', 0, G_OPTION_ARG_NONE, &rpc_design_only_first_pass, "Only first pass", NULL}, {"secondpass", '2', 0, G_OPTION_ARG_NONE, &rpc_design_only_second_pass, "Only second pass", NULL}, {"interface", 'i', 0, G_OPTION_ARG_FILENAME, &rpc_design_input_file, "Interface file (input). Default is " RPC_DESIGN_def_input_file, NULL}, {"stub", 'u', 0, G_OPTION_ARG_FILENAME, &rpc_design_stub_file, "Stub classes file. Default is " RPC_DESIGN_def_stub_file, NULL}, {"skeleton", 'k', 0, G_OPTION_ARG_FILENAME, &rpc_design_skel_file, "Skeleton classes file. Default is " RPC_DESIGN_def_skel_file, NULL}, {"temp-file", (gchar) 0, 0, G_OPTION_ARG_FILENAME, &rpc_design_temp_file, "Temporary definition file. Default is " RPC_DESIGN_def_temp_file, NULL}, {NULL}};

static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


gint rpc_design_main (gchar** args, int args_length1) {
	gint result = 0;
	GOptionContext* _tmp0_;
	GOptionContext* oc;
	GOptionContext* _tmp1_;
	gboolean _tmp9_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_;
	gboolean _tmp18_;
	const gchar* _tmp20_;
	const gchar* _tmp22_;
	const gchar* _tmp24_;
	const gchar* _tmp26_;
	gboolean _tmp28_;
	gboolean _tmp48_;
	GError * _inner_error_ = NULL;
	_tmp0_ = g_option_context_new ("- Parses interface and produce stub and skeleton classes.");
	oc = _tmp0_;
	_tmp1_ = oc;
	g_option_context_add_main_entries (_tmp1_, RPC_DESIGN_options, NULL);
	{
		GOptionContext* _tmp2_;
		_tmp2_ = oc;
		g_option_context_parse (_tmp2_, &args_length1, &args, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (oc);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = stdout;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error parsing options: ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		fprintf (_tmp3_, "%s", _tmp8_);
		_g_free0 (_tmp8_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (oc);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_option_context_free0 (oc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp9_ = rpc_design_version;
	if (_tmp9_) {
		FILE* _tmp10_;
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		_tmp10_ = stdout;
		_tmp11_ = string_to_string (PACKAGE_NAME);
		_tmp12_ = string_to_string (PACKAGE_VERSION);
		_tmp13_ = g_strconcat (_tmp11_, " ", _tmp12_, "\n", NULL);
		_tmp14_ = _tmp13_;
		fprintf (_tmp10_, "%s", _tmp14_);
		_g_free0 (_tmp14_);
		result = 0;
		_g_option_context_free0 (oc);
		return result;
	}
	_tmp16_ = rpc_design_only_first_pass;
	if (_tmp16_) {
		gboolean _tmp17_;
		_tmp17_ = rpc_design_only_second_pass;
		_tmp15_ = _tmp17_;
	} else {
		_tmp15_ = FALSE;
	}
	_tmp18_ = _tmp15_;
	if (_tmp18_) {
		FILE* _tmp19_;
		_tmp19_ = stdout;
		fprintf (_tmp19_, "Cannot use flags firstpass and secondpass together.\n");
		result = 1;
		_g_option_context_free0 (oc);
		return result;
	}
	_tmp20_ = rpc_design_input_file;
	if (_tmp20_ == NULL) {
		gchar* _tmp21_;
		_tmp21_ = g_strdup (RPC_DESIGN_def_input_file);
		_g_free0 (rpc_design_input_file);
		rpc_design_input_file = _tmp21_;
	}
	_tmp22_ = rpc_design_stub_file;
	if (_tmp22_ == NULL) {
		gchar* _tmp23_;
		_tmp23_ = g_strdup (RPC_DESIGN_def_stub_file);
		_g_free0 (rpc_design_stub_file);
		rpc_design_stub_file = _tmp23_;
	}
	_tmp24_ = rpc_design_skel_file;
	if (_tmp24_ == NULL) {
		gchar* _tmp25_;
		_tmp25_ = g_strdup (RPC_DESIGN_def_skel_file);
		_g_free0 (rpc_design_skel_file);
		rpc_design_skel_file = _tmp25_;
	}
	_tmp26_ = rpc_design_temp_file;
	if (_tmp26_ == NULL) {
		gchar* _tmp27_;
		_tmp27_ = g_strdup (RPC_DESIGN_def_temp_file);
		_g_free0 (rpc_design_temp_file);
		rpc_design_temp_file = _tmp27_;
	}
	_tmp28_ = rpc_design_only_second_pass;
	if (!_tmp28_) {
		const gchar* _tmp29_;
		gboolean _tmp30_ = FALSE;
		gboolean _tmp36_ = FALSE;
		gboolean _tmp37_;
		gboolean _tmp40_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		_tmp29_ = rpc_design_input_file;
		_tmp30_ = g_file_test (_tmp29_, G_FILE_TEST_EXISTS);
		if (!_tmp30_) {
			FILE* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_ = NULL;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_;
			_tmp31_ = stderr;
			_tmp32_ = rpc_design_input_file;
			_tmp33_ = string_to_string (_tmp32_);
			_tmp34_ = g_strconcat ("Source file ", _tmp33_, " not found.\n", NULL);
			_tmp35_ = _tmp34_;
			fprintf (_tmp31_, "%s", _tmp35_);
			_g_free0 (_tmp35_);
			result = 1;
			_g_option_context_free0 (oc);
			return result;
		}
		_tmp37_ = rpc_design_force_ovw;
		if (!_tmp37_) {
			const gchar* _tmp38_;
			gboolean _tmp39_ = FALSE;
			_tmp38_ = rpc_design_temp_file;
			_tmp39_ = g_file_test (_tmp38_, G_FILE_TEST_EXISTS);
			_tmp36_ = _tmp39_;
		} else {
			_tmp36_ = FALSE;
		}
		_tmp40_ = _tmp36_;
		if (_tmp40_) {
			FILE* _tmp41_;
			const gchar* _tmp42_;
			const gchar* _tmp43_ = NULL;
			gchar* _tmp44_ = NULL;
			gchar* _tmp45_;
			_tmp41_ = stderr;
			_tmp42_ = rpc_design_temp_file;
			_tmp43_ = string_to_string (_tmp42_);
			_tmp44_ = g_strconcat ("Destination file ", _tmp43_, " exists.\n", NULL);
			_tmp45_ = _tmp44_;
			fprintf (_tmp41_, "%s", _tmp45_);
			_g_free0 (_tmp45_);
			result = 1;
			_g_option_context_free0 (oc);
			return result;
		}
		_tmp46_ = rpc_design_input_file;
		_tmp47_ = rpc_design_temp_file;
		first_pass_firstpass (_tmp46_, _tmp47_);
	}
	_tmp48_ = rpc_design_only_first_pass;
	if (!_tmp48_) {
		const gchar* _tmp49_;
		gboolean _tmp50_ = FALSE;
		gboolean _tmp56_ = FALSE;
		gboolean _tmp57_;
		gboolean _tmp60_;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_;
		gboolean _tmp70_;
		const gchar* _tmp76_;
		const gchar* _tmp77_;
		const gchar* _tmp78_;
		_tmp49_ = rpc_design_temp_file;
		_tmp50_ = g_file_test (_tmp49_, G_FILE_TEST_EXISTS);
		if (!_tmp50_) {
			FILE* _tmp51_;
			const gchar* _tmp52_;
			const gchar* _tmp53_ = NULL;
			gchar* _tmp54_ = NULL;
			gchar* _tmp55_;
			_tmp51_ = stderr;
			_tmp52_ = rpc_design_temp_file;
			_tmp53_ = string_to_string (_tmp52_);
			_tmp54_ = g_strconcat ("Source file ", _tmp53_, " not found.\n", NULL);
			_tmp55_ = _tmp54_;
			fprintf (_tmp51_, "%s", _tmp55_);
			_g_free0 (_tmp55_);
			result = 1;
			_g_option_context_free0 (oc);
			return result;
		}
		_tmp57_ = rpc_design_force_ovw;
		if (!_tmp57_) {
			const gchar* _tmp58_;
			gboolean _tmp59_ = FALSE;
			_tmp58_ = rpc_design_stub_file;
			_tmp59_ = g_file_test (_tmp58_, G_FILE_TEST_EXISTS);
			_tmp56_ = _tmp59_;
		} else {
			_tmp56_ = FALSE;
		}
		_tmp60_ = _tmp56_;
		if (_tmp60_) {
			FILE* _tmp61_;
			const gchar* _tmp62_;
			const gchar* _tmp63_ = NULL;
			gchar* _tmp64_ = NULL;
			gchar* _tmp65_;
			_tmp61_ = stderr;
			_tmp62_ = rpc_design_stub_file;
			_tmp63_ = string_to_string (_tmp62_);
			_tmp64_ = g_strconcat ("Destination file ", _tmp63_, " exists.\n", NULL);
			_tmp65_ = _tmp64_;
			fprintf (_tmp61_, "%s", _tmp65_);
			_g_free0 (_tmp65_);
			result = 1;
			_g_option_context_free0 (oc);
			return result;
		}
		_tmp67_ = rpc_design_force_ovw;
		if (!_tmp67_) {
			const gchar* _tmp68_;
			gboolean _tmp69_ = FALSE;
			_tmp68_ = rpc_design_skel_file;
			_tmp69_ = g_file_test (_tmp68_, G_FILE_TEST_EXISTS);
			_tmp66_ = _tmp69_;
		} else {
			_tmp66_ = FALSE;
		}
		_tmp70_ = _tmp66_;
		if (_tmp70_) {
			FILE* _tmp71_;
			const gchar* _tmp72_;
			const gchar* _tmp73_ = NULL;
			gchar* _tmp74_ = NULL;
			gchar* _tmp75_;
			_tmp71_ = stderr;
			_tmp72_ = rpc_design_skel_file;
			_tmp73_ = string_to_string (_tmp72_);
			_tmp74_ = g_strconcat ("Destination file ", _tmp73_, " exists.\n", NULL);
			_tmp75_ = _tmp74_;
			fprintf (_tmp71_, "%s", _tmp75_);
			_g_free0 (_tmp75_);
			result = 1;
			_g_option_context_free0 (oc);
			return result;
		}
		_tmp76_ = rpc_design_temp_file;
		_tmp77_ = rpc_design_stub_file;
		_tmp78_ = rpc_design_skel_file;
		second_pass_secondpass (_tmp76_, _tmp77_, _tmp78_);
	}
	result = 0;
	_g_option_context_free0 (oc);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return rpc_design_main (argv, argc);
}


RpcDesign* rpc_design_construct (GType object_type) {
	RpcDesign* self = NULL;
	self = (RpcDesign*) g_type_create_instance (object_type);
	return self;
}


RpcDesign* rpc_design_new (void) {
	return rpc_design_construct (TYPE_RPC_DESIGN);
}


static void value_rpc_design_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_rpc_design_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		rpc_design_unref (value->data[0].v_pointer);
	}
}


static void value_rpc_design_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = rpc_design_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_rpc_design_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_rpc_design_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		RpcDesign* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = rpc_design_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_rpc_design_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	RpcDesign** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = rpc_design_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_rpc_design (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecRpcDesign* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_RPC_DESIGN), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_rpc_design (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RPC_DESIGN), NULL);
	return value->data[0].v_pointer;
}


void value_set_rpc_design (GValue* value, gpointer v_object) {
	RpcDesign* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RPC_DESIGN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RPC_DESIGN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		rpc_design_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		rpc_design_unref (old);
	}
}


void value_take_rpc_design (GValue* value, gpointer v_object) {
	RpcDesign* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RPC_DESIGN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RPC_DESIGN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		rpc_design_unref (old);
	}
}


static void rpc_design_class_init (RpcDesignClass * klass) {
	rpc_design_parent_class = g_type_class_peek_parent (klass);
	RPC_DESIGN_CLASS (klass)->finalize = rpc_design_finalize;
}


static void rpc_design_instance_init (RpcDesign * self) {
	self->ref_count = 1;
}


static void rpc_design_finalize (RpcDesign* obj) {
	RpcDesign * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RPC_DESIGN, RpcDesign);
}


GType rpc_design_get_type (void) {
	static volatile gsize rpc_design_type_id__volatile = 0;
	if (g_once_init_enter (&rpc_design_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_rpc_design_init, value_rpc_design_free_value, value_rpc_design_copy_value, value_rpc_design_peek_pointer, "p", value_rpc_design_collect_value, "p", value_rpc_design_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (RpcDesignClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rpc_design_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RpcDesign), 0, (GInstanceInitFunc) rpc_design_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType rpc_design_type_id;
		rpc_design_type_id = g_type_register_fundamental (g_type_fundamental_next (), "RpcDesign", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&rpc_design_type_id__volatile, rpc_design_type_id);
	}
	return rpc_design_type_id__volatile;
}


gpointer rpc_design_ref (gpointer instance) {
	RpcDesign* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void rpc_design_unref (gpointer instance) {
	RpcDesign* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		RPC_DESIGN_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



